EDIT - task #9567

Unify HomotypicGroupTaxonComparator and HomotypicGroupNameComparator
03/29/2021 08:46 PM - Andreas Mdller

Status: Closed Start date:

Priority: New Due date:

Assignee: Andreas Muller % Done: 50%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 5.22

Severity: normal

Description

Both classes have mostly the same code so they are very redundant. HGNameComparator seems to be an adapted copy of
HGTaxonComparator.

Related issues:
Related to EDIT - bug #9566: Handle nomenclatural standing correctly in cdmli... Closed
Related to EDIT - task #9576: Add tests for homotypic group name comparator Rejected

Associated revisions

Revision 8432293f - 03/29/2021 08:46 PM - Andreas Miiller

fix #9567 unify HomotypicGroupTaxonComparator and HomotypicGroupNameComparator

Revision ee68d8ba - 03/30/2021 08:37 AM - Katja Luther

ref #9567: fix handleSameBasionym comparison

Revision 7555e895 - 03/30/2021 12:13 PM - Andreas Miiller

ref #9567 fix potential NPE in TaxonComparator if used in HomotypicGroupNameComparator

Revision e0c610f1 - 03/30/2021 12:23 PM - Andreas Miiller

fix #9567 fix missing defined order if names differ only in hybrid sign

Revision c5bd49b5 - 03/30/2021 12:29 PM - Andreas Miiller
ref #9567 slightly adapt the last fix

Revision c441166b - 03/30/2021 07:40 PM - Andreas Miiller
ref #9567 adapt javadoc

History

#1 - 03/29/2021 08:46 PM - Andreas Miiller
- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib|8432293fbc9496c0b4c50bda3516ef9e0ac3b984.

#2 - 03/29/2021 08:47 PM - Andreas Miuiller
- Related to bug #9566: Handle nomenclatural standing correctly in cdmlight / sorting algorithms added

#3 - 03/29/2021 09:13 PM - Andreas Miuller

- Assignee changed from Andreas Miiller to Katja Luther

please review

#4 - 03/30/2021 08:46 AM - Katja Luther

- Status changed from Resolved to Feedback
- Assignee changed from Katja Luther to Andreas Miiller

In handleSameBasionym a return was missing. After fixing that the result is correct.
But maybe the NPE should be avoid if no taxonBases available?

#5 - 03/30/2021 10:11 AM - Andreas Miiller
Katja Luther wrote:
In handleSameBasionym a return was missing. After fixing that the result is correct.

But maybe the NPE should be avoid if no taxonBases available?

Which NPE do you mean? Which line?
#6 - 03/30/2021 10:36 AM - Katja Luther
Andreas Muller wrote:
Katja Luther wrote:
In handleSameBasionym a return was missing. After fixing that the result is correct.

But maybe the NPE should be avoid if no taxonBases available?

Which NPE do you mean? Which line?
if in compareNames the value of compareResult == 0 the taxa should be compared, but if there are no taxa a NPE is thrown. (line 142)

#7 - 03/30/2021 11:24 AM - Katja Luther

Katja Luther wrote:
Andreas Miller wrote:
Katja Luther wrote:
In handleSameBasionym a return was missing. After fixing that the result is correct.

But maybe the NPE should be avoid if no taxonBases available?

Which NPE do you mean? Which line?
if in compareNames the value of compareResult == 0 the taxa should be compared, but if there are no taxa a NPE is thrown. (line 142)

for example the comparison of Opuntia xrubiflora Davidson and Opuntia rubiflora Davidson returns 0 and then the taxa should be compared. Also that
the comparison results 0 is not correct?

#8 - 03/30/2021 11:42 AM - Katja Luther

| would add another comparison if the first two comparisons return 0 to compare the not normalized titleCache, do you agree?

#9 - 03/30/2021 12:23 PM - Andreas Miuller

- Status changed from Feedback to Resolved

Applied in changeset cdmlible0c610f10302b0c755{509a33bd3df645077eab9.

#10 - 03/30/2021 12:27 PM - Andreas Miiller

- Status changed from Resolved to Feedback

| fixed the potetial NPE and adapted the compare to include hybrid sign if names do not differ in any other part.

#11 - 03/30/2021 12:37 PM - Andreas Miiller
- Status changed from Feedback to Resolved

- Assignee changed from Andreas Miiller to Katja Luther

The mentioned issues should be fixed.
Maybe you can still add some tests for HomotypicGroupNameComparator which explicitly handle specific issues for name comparison so the
HomotypicGroupNameComparator is also covered by tests. Especially the NPE case should be covered.

#12 - 04/01/2021 11:56 AM - Katja Luther
- Status changed from Resolved to Closed

- Assignee changed from Katja Luther to Andreas Miiller
this issue seems to be fixed. add a new ticket for the tests.

#13 - 04/01/2021 11:58 AM - Katja Luther
- Related to task #9576: Add tests for homotypic group name comparator added
